from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Array, Int, Float, File, String, Boolean

Tombo_Model_Resquiggle_V0_1_0 = CommandToolBuilder(tool="tombo_model_resquiggle", base_command=["tombo", "model_resquiggle"], inputs=[ToolInput(tag="in_fast_five_based_irs", input_type=Array(t=Int(), optional=True), prefix="--fast5-basedirs", doc=InputDocumentation(doc="Directories containing fast5 files.")), ToolInput(tag="in_stouffer_z_context", input_type=Int(optional=True), prefix="--stouffer-z-context", doc=InputDocumentation(doc="Number of context bases up and downstream over which\nto compute Stouffer's Z combined z-scores. Default: 1.")), ToolInput(tag="in_region_context", input_type=Int(optional=True), prefix="--region-context", doc=InputDocumentation(doc="Number of context bases up and downstream of poorly\nfit regions to perform model re-squiggle. Default: 1.")), ToolInput(tag="in_p_value_threshold", input_type=Float(optional=True), prefix="--p-value-threshold", doc=InputDocumentation(doc="P-value threshold to identify regions to apply model\nre-squiggle algorithm. Default: 0.100000")), ToolInput(tag="in_tombo_model_filename", input_type=File(optional=True), prefix="--tombo-model-filename", doc=InputDocumentation(doc="Tombo model for event-less resquiggle and significance\ntesting. If no model is provided the default DNA or\nRNA tombo model will be used.")), ToolInput(tag="in_max_bases_shift", input_type=Int(optional=True), prefix="--max-bases-shift", doc=InputDocumentation(doc="Maximum bases to shift raw signal from\nevent_resquiggle assignment. Default: 3")), ToolInput(tag="in_min_obs_per_base", input_type=Int(optional=True), prefix="--min-obs-per-base", doc=InputDocumentation(doc="Minimum raw observations to assign to a genomic base.\nDefault: 3")), ToolInput(tag="in_base_score_iterations", input_type=Int(optional=True), prefix="--base-score-iterations", doc=InputDocumentation(doc="Number of iterations through each read to perform\n(computationally expensive) base space model re-\nsquiggle algorithm. Default: 2.")), ToolInput(tag="in_base_score_region_context", input_type=Int(optional=True), prefix="--base-score-region-context", doc=InputDocumentation(doc="Number of context bases up and downstream of poorly\nfit regions to perform iterative base-score model re-\nsquiggle. Default: 4.")), ToolInput(tag="in_base_score_max_bases_shift", input_type=Int(optional=True), prefix="--base-score-max-bases-shift", doc=InputDocumentation(doc="Maximum bases to shift raw signal from first round of\nmodel re-squiggle. Default: 4")), ToolInput(tag="in_corrected_group", input_type=Int(optional=True), prefix="--corrected-group", doc=InputDocumentation(doc="FAST5 group created by resquiggle command. Default:\nRawGenomeCorrected_000")), ToolInput(tag="in_new_corrected_group", input_type=Int(optional=True), prefix="--new-corrected-group", doc=InputDocumentation(doc="FAST5 group created by resquiggle command. Default:\nRawModelCorrected_000")), ToolInput(tag="in_base_call_subgroups", input_type=Array(t=String(), optional=True), prefix="--basecall-subgroups", doc=InputDocumentation(doc="FAST5 subgroup(s) (under Analyses/[corrected-group])\ncontaining basecalls. Default: ['BaseCalled_template']")), ToolInput(tag="in_overwrite", input_type=Boolean(optional=True), prefix="--overwrite", doc=InputDocumentation(doc="Overwrite previous corrected group in FAST5 files.\nNote: only effects --corrected-group or --new-\ncorrected-group.")), ToolInput(tag="in_failed_reads_filename", input_type=File(optional=True), prefix="--failed-reads-filename", doc=InputDocumentation(doc="Output failed read filenames with assoicated error.\nDefault: Do not store failed reads.")), ToolInput(tag="in_include_event_stdev", input_type=Boolean(optional=True), prefix="--include-event-stdev", doc=InputDocumentation(doc="Include corrected event standard deviation in output\nFAST5 data.")), ToolInput(tag="in_processes", input_type=Int(optional=True), prefix="--processes", doc=InputDocumentation(doc="Number of processes. Default: 1")), ToolInput(tag="in_quiet", input_type=Boolean(optional=True), prefix="--quiet", doc=InputDocumentation(doc="Don't print status information."))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Tombo_Model_Resquiggle_V0_1_0().translate("wdl", allow_empty_container=True)

